

function love.load()


 Position = {
 	20, 30, 50, 60
 }
 

Bullets = {}
bulletSpeed = 250
bulletType = 1
ammo = 10

ammoPowerUp = {
	x = 50,
	y = 50,
}
powerupCollide = false

Player = {
	radius = 6,
	x = 500,
	y = love.graphics.getHeight() / 2,
	speed = 200,
	health = 5
}

--------------------------------------------
------------enemy creation----------
--------------------------------------------

Enemies = {}

for i = 0, 11 do 
	enemy = {}
	enemy.radius = 3
    enemy.x = i * Position[math.random(1, 4)]
    enemy.y = i * Position[math.random(1, 4)]
    enemy.speed = 100
    table.insert(Enemies, enemy)
end

Chasers = {}
for i = 0, 11 do 
	chaser = {}
	chaser.radius = 3
    chaser.x = i * Position[math.random(1, 4)]
    chaser.y = i * Position[math.random(1, 4)]
    chaser.speed = 170
    table.insert(Chasers, chaser)
end


timer = 0
score = 0


end


function love.update(dt)
--------------------------------------------
------------Zombie follow------------
--------------------------------------------
for i,v in ipairs(Enemies) do
    local angle = math.atan2(Player.y - v.y , Player.x - v.x)

    v.x = v.x + math.cos(angle)*v.speed*dt
    v.y = v.y + math.sin(angle)*v.speed*dt
end

--------------------------------------------
------------chaser follow------------
--------------------------------------------
for i,v in ipairs(Chasers) do
    local angle = math.atan2(Player.y - v.y , Player.x - v.x)

    v.x = v.x + math.cos(angle)*v.speed*dt
    v.y = v.y + math.sin(angle)*v.speed*dt
end

--------------------------------------------
------------Controls--------------------
--------------------------------------------

    if love.keyboard.isDown("d") then
    	Player.x = Player.x + (Player.speed * dt)
    end
    
        if love.keyboard.isDown("a") then
    	Player.x = Player.x - (Player.speed * dt)
    end
    
            if love.keyboard.isDown("w") then
    	Player.y = Player.y - (Player.speed * dt)
    end
    
            if love.keyboard.isDown("s") then
    	Player.y = Player.y + (Player.speed * dt)
    end
    
--------------------------------------------
------------Collision--------------------
--------------------------------------------
    
for i,v in ipairs(Enemies) do
    if checkCircularCollision(Player.x, Player.y, v.x, v.y, Player.radius, v.radius) == true then
    	if Player.health > 0 then
    		Player.health = Player.health - 1
			table.remove(Enemies, i)	    		
    	else
    	gameOver = true
    	end
    end
end    

for i,v in ipairs(Chasers) do
    if checkCircularCollision(Player.x, Player.y, v.x, v.y, Player.radius, v.radius) == true then
    	if Player.health > 0 then
    		Player.health = Player.health - 1
			table.remove(Chasers, i)	    		
    	else
    	gameOver = true
    	end
    end
end    

for i,v in ipairs(Enemies) do 
	for ii, vv in ipairs(Bullets) do 
		if checkCircularCollision(v.x, v.y, vv["x"], vv["y"], v.radius, 3) == true then
			bulletHit = true
			score = score + 10
			table.remove(Enemies, i)	
			table.remove(Bullets, ii)					
		end
	end
end

for i,v in ipairs(Chasers) do 
	for ii, vv in ipairs(Bullets) do 
		if checkCircularCollision(v.x, v.y, vv["x"], vv["y"], v.radius, 3) == true then
			bulletHit = true
			score = score + 10
			table.remove(Chasers, i)	
			table.remove(Bullets, ii)					
		end
	end
end

if checkCircularCollision(Player.x, Player.y, ammoPowerUp.x, ammoPowerUp.y, Player.radius, 4) == true then
	ammo = ammo + 2
	powerupCollide = true
end

--------------------------------------------
------------Bullets-----------
--------------------------------------------
    for i,v in ipairs(Bullets) do
        v["x"] = v["x"] + (v["dx"] * dt)
        v["y"] = v["y"] + (v["dy"] * dt)
    end




timer = math.floor(timer + dt * 100)


end

function love.draw()

--------------------------------------------
------------draw player---------------
--------------------------------------------
love.graphics.setColor(255,10,200)
love.graphics.circle("fill", Player.x, Player.y, Player.radius)

--------------------------------------------
------------draw enemies------------
--------------------------------------------

--zombie
love.graphics.setColor(255,240,200)
for i,v in ipairs(Enemies) do
    love.graphics.circle("fill", v.x, v.y, v.radius)
end

--chaser
love.graphics.setColor(255,255,0)
for i,v in ipairs(Chasers) do
    love.graphics.circle("fill", v.x, v.y, v.radius)
end

--------------------------------------------
------------draw bullets--------------
--------------------------------------------

--bullets
 love.graphics.setColor(128, 128, 128)
 if bulletType == 1 then
    for i,v in ipairs(Bullets) do
        love.graphics.circle("fill", v["x"], v["y"], 3)
    end
end
    
--draw ammo
love.graphics.print(ammo, 10, 65)
    
--------------------------------------------
------------draw health---------------
--------------------------------------------
love.graphics.print(Player.health, 10, 50)
   
--------------------------------------------
------------draw score----------------
--------------------------------------------
   love.graphics.print(score, 30, 50)


--------------------------------------------
------------draw debug---------------
--------------------------------------------
if gameOver == true then
love.graphics.print("lose!", 20, 20)
end

if bulletHit == true then
	love.graphics.print("hit!", 50, 20)
end

love.graphics.setColor(255, 0, 0)
if powerupCollide == false then
	love.graphics.circle("fill", ammoPowerUp.x, ammoPowerUp.y, 4)
end

end

function checkCircularCollision(ax, ay, bx, by, ar, br)
    local dx = bx - ax
    local dy = by - ay
    local dist = math.sqrt(dx * dx + dy * dy)
    return dist < ar + br
end

function love.mousepressed(x, y, button)
    if button == "l" and ammo > 0 then
        local startX = Player.x + 3
        local startY = Player.y+ 3
        local mouseX = x
        local mouseY = y
       
        local angle = math.atan2((mouseY - startY), (mouseX - startX))
       
        local bulletDx = bulletSpeed * math.cos(angle)
        local bulletDy = bulletSpeed * math.sin(angle)
        ammo = ammo - 1       
        table.insert(Bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy,})
    
    end
end

